/* XXX: a kludge so that we can pass a variable number of NULL-termed strings in the message */
struct s_trans_str {
	string		text<>;
};
typedef struct s_trans_str s_trans_str;


/*
 with stransd and knfsd:
 - VOID:    no input; no output.
 - LOAD:    read input srv boottime; stransd gives knfsd list of clids as output.
 - ADD:     read input 1 clid, 1 clip, 1 client boottime; no output.
 - REMOVE:  read input 1 clid; no output.
 - ENTER:   no input; no output.
 - EXIT:    no input; no output.
 - MIGRATE: read input 1 clIP and 1 sIP; no output;

 with stransd and RPC client:
 - LOAD:    no in; no out  (2nd half of LOAD with clids is just sent down)
 .. all others are the same
*/

struct s_trans_simple_cmd {
	u_int		sm_type;
};

struct s_trans_add_cmd {
	u_int		sm_type;
	s_trans_str	sm_data<>;
	u_int		sm_client_ip;
	u_int		sm_client_boottime;
};

struct s_trans_remove_cmd {
	u_int		sm_type;
	s_trans_str	sm_data<>;
};

struct s_trans_migrate_cmd {
	u_int		sm_client_ip;
	u_int		sm_server_ip;
};

program S_TRANS_PROG {
	version S_TRANS_VERS {
		u_int	S_TRANS_VOID(void) = 1;
		u_int	S_TRANS_LOAD_REBOOT_STATE(struct s_trans_simple_cmd) = 2;
		u_int	S_TRANS_ADD_STATE(struct s_trans_add_cmd) = 3;
		u_int	S_TRANS_REMOVE_STATE(struct s_trans_remove_cmd) = 4;
		u_int	S_TRANS_ENTER_GRACE(struct s_trans_simple_cmd) = 5;
		u_int	S_TRANS_EXIT_GRACE(struct s_trans_simple_cmd) = 6;
		u_int	S_TRANS_MIGRATE_CLIENT(struct s_trans_migrate_cmd) = 7;
	} = 1;
} = 555555;
